#-*- mode: python; mode: fold -*-
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import ModifyPortalContent
from Products.CPSCore.CPSBase import CPSBase_adder, CPSBaseFolder 
#from Products.CPSCore.CPSBase import CPSBaseDocument as BaseDocument 
from Products.CPSDocument.CPSDocument import CPSDocument 
#from Products.CPSCore.CPSBase import CPSBaseBTreeFolder as BaseBTreeFolder 
#from Products.CPSCore.CPSBase import CPSBaseBTreeDocument as BaseBTreeDocument 
#from Products.CMFCore.DirectoryView import registerDirectory

#registerDirectory('skins', globals())
#registerDirectory('skins/waeup_default', globals())
#registerDirectory('skins/waeup_faculty', globals())

class Faculty(CPSDocument): ###(
    """
    WAeUP Faculty containing Departments 
    """
    meta_type = 'Faculty'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
    def __init__(self, id, **kw):
        CPSDocument.__init__(self, id, **kw)

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        return "Faculty of %s" % (self.title)

InitializeClass(Faculty)

def addFaculty(container, id, REQUEST=None, **kw):
    """Add a Faculty."""
    ob = Faculty(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)


class Department(CPSDocument): ###(
    """
    WAeUP Department containing the courses and students
    """
    meta_type = 'Department'
    portal_type = meta_type
    security = ClassSecurityInfo()

##    security.declareProtected(View,"Title")
##    def Title(self):
##        """compose title"""
##        reg_nr = self.getId()[1:]
##        return "Department of %s" % (self.title)

InitializeClass(Department)

def addDepartment(container, id, REQUEST=None, **kw):
    """Add a Department."""
    ob = Department(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)

##course_fti = { ###(
##    'title': 'WAeUP Course',
##    'description': '',
##    'content_icon': '',
##    'content_meta_type': 'Course',
##    'factory': 'addCourse',
##    'immediate_view': 'cpsdocument_view',
##    'global_allow': True,
##    'filter_content_types': True,
##    'allowed_content_types': (),
##    'allow_discussion': False,
##}
#####)

class Course(CPSDocument): ###(
    """
    WAeUP Course  
    """
    meta_type = 'Course'
    portal_type = meta_type
    security = ClassSecurityInfo()

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        content = self.getContent()
        heading = getattr(content,'heading',None)
        if heading is None:
            return self.title
        return heading
    
InitializeClass(Course)

def addCourse(container, id, REQUEST=None, **kw):
    """Add a Course."""
    ob = Course(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)

class CourseTicket(CPSDocument): ###(
    """
    WAeUP CourseTicket  
    """
    meta_type = 'CourseTicket'
    portal_type = meta_type
    security = ClassSecurityInfo()
    
InitializeClass(CourseTicket)

def addCourseTicket(container, id, REQUEST=None, **kw):
    """Add a CourseTicket."""
    ob = CourseTicket(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)
###)
